<?php

    error_reporting(E_ERROR  | E_PARSE | E_WARNING);

    header('Content-Type: application/json');
    /* Connect to an ODBC database using driver invocation */
    $dsn = 'mysql:dbname=dbname;host=127.0.0.1';
    $user = 'user';
    $password = 'user';


    try {
        $db = new PDO($dsn, $user, $password);
    } catch (PDOException $e) {
        echo 'Connection failed: ' . $e->getMessage();
    }


    require("php/grid_connector.php"); // connector file
    require("php/data_connector.php"); // connector file
    require("php/db_pdo.php");// DB lib



    $gridConn = new GridConnector($db,"PDO");



    if ($gridConn->is_select_mode()) {
        /* QUERY MODE */

        /* this will return a XML file but i need a JSON file.
        *  also this will return one value for each DB cell but in the grid i need
        *  four DB values (cells) in one grid cell.
        *  thats why i decide to create the JSON with a custom script as you can see here:
        */

//        $gridConn->render_table("gridlight","id","name,assetsTotal,assetsDone,status,user"); // returns a xml ;(

        /* http://docs.dhtmlx.com/connector__php__grid_stucture.html */
        $return = '{'
        /* header config, from a database table A */
        .'    "head":['
        .'        { "id":"name",     "width":165,  "type":"txt",     "align":"left",   "sort":"str",        "value":"Name" },'
        .'        { "id":"status",   "width":225,  "type":"status",  "align":"center", "sort":"str",        "value":"Status" }'
        .'    ],'
        /* additional informatation, form a database table B */
        .'    "status":{'
        .'        "status":{'
        .'            "11":{"id":"11", "name":"asdf", "color":"#fcffee"},'
        .'            "12":{"id":"12", "name":"qwer", "color":"#ffe14f"},'
        .'        }'
        .'    },'
        .'    "rows":[';

        /* row informations from a database table C
        *  also a history is saved in this table C, this means it is posible to have more than
        *  one DB row per grid cell. */
        $sql = 'SELECT * FROM `grid` ORDER BY `name`';

        foreach ($db->query($sql) as $row){
            $return .='        {'
            .'            "id":'. $row["id"] .','
            .'            "data":['
            .'                "'. $row["name"] .'",'
            /* i need to use this to be able to have more than one DB cell in one grid cell */
            .'                {'
            .'                    "value":{'
            .'                        "assetsTotal":"'. $row["assetsTotal"] .'",'
            .'                        "assetsDone":"'. $row["assetsDone"] .'",'
            .'                        "status":"'. $row["status"] .'",'
            .'                        "name":"'. $row["user"] .'"'
            .'                    }'
            .'                }'
            .'            ]'
            .'        },';
        }

        $return .='    ]'
        .'}';

        /* return the JSON */
        echo $return;

    } else {
        /* UPDATE MODE */

        $gridJSONConn = new JSONDataConnector($conn,"PDO");
        $gridJSONConn->enable_log("log.log",true);
        $gridJSONConn->useModel(new EventModel());
        $gridJSONConn->render();

    }


class EventModel{
    function update($action){
        /* at this point i am unable to access the returned data.
        *  as you can see in the return message the "status" is just a
        *  string: "[object Object]". even the predefined "head" is just a
        *  string with the same value.
        *  i also tried your provided excells examples "mytime" and "myprice"
        *  http://docs.dhtmlx.com/grid__columns_types.html#customcolumntypes
        *  but it always returns just a string "[object Object]".
        *
        *  the question is, how can i access the returned JSON object?
        */

        echo var_dump($action->get_data());
    }
} // end of class EventModel

?>